<div id="slabs-custom-component">
  @if (!isWizard) {
    <h3 class="mt-0">Conformance tests</h3>
  }
  <table
    mat-table
    [dataSource]="tableDataSource"
    matSort
    class="components-table border-grey-300"
    [ngClass]="{ 'is-wizard': isWizard }"
    aria-label="Custom components list table"
  >
    <ng-container matColumnDef="selectComponent">
      <th mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let customComponent">
        <mat-radio-group [(ngModel)]="selectedComponent" color="primary">
          <mat-radio-button
            class="change-component-radio-button"
            [value]="customComponent"
            (change)="selectComponent(customComponent)"
          ></mat-radio-button>
        </mat-radio-group>
      </td>
    </ng-container>
    <ng-container matColumnDef="name">
      <th
        mat-header-cell
        *matHeaderCellDef
        mat-sort-header
        sortActionDescription="Sort by component name"
      >
        Component
      </th>
      <td mat-cell *matCellDef="let customComponent">
        {{ customComponent.name }}
      </td>
    </ng-container>

    <ng-container matColumnDef="version">
      <th
        mat-header-cell
        *matHeaderCellDef
        mat-sort-header
        sortActionDescription="Sort by version"
      >
        Version
      </th>
      <td mat-cell *matCellDef="let customComponent">
        {{ customComponent.version }}
      </td>
    </ng-container>

    <ng-container matColumnDef="specificationDescription">
      <th
        mat-header-cell
        *matHeaderCellDef
        mat-sort-header
        sortActionDescription="Sort by specification"
      >
        Specification
      </th>
      <td mat-cell *matCellDef="let customComponent">
        {{ customComponent.specificationDescription }}
      </td>
    </ng-container>

    <ng-container matColumnDef="status">
      <th
        mat-header-cell
        *matHeaderCellDef
        mat-sort-header
        sortActionDescription="Sort by status"
      >
        Status
      </th>
      <td mat-cell *matCellDef="let customComponent">
        <div class="slabs-comp ec-chips-theme">
          <mat-chip
            highlighted
            class="slabs-chip"
            [color]="status2ChipColor.get(customComponent.status.toUpperCase())"
          >
            {{ customComponent.status }}
          </mat-chip>
        </div>
      </td>
    </ng-container>

    <ng-container matColumnDef="result">
      <th
        mat-header-cell
        *matHeaderCellDef
        mat-sort-header
        sortActionDescription="Sort by result"
      >
        Result
      </th>
      <td mat-cell *matCellDef="let customComponent">
        <app-test-result-bar
          [resultNotExecuted]="customComponent.resultNotExecuted"
          [resultError]="customComponent.resultError"
          [resultSuccess]="customComponent.resultSuccess"
        ></app-test-result-bar>

        @if (
          customComponent.resultSuccess > 0 || customComponent.resultError > 0
        ) {
          <div class="d-flex align-items-center mb-0 mt-4px">
            {{ customComponent.resultSuccess | percent: "1.0-1" }}
            <mat-icon class="check-circle-icon text-success">
              check_circle
            </mat-icon>

            {{ customComponent.resultError | percent: "1.0-1" }}
            <mat-icon class="cancel-icon text-error">cancel</mat-icon>

            {{ customComponent.resultNotExecuted | percent: "1.0-1" }}
            <mat-icon class="block-icon text-grey-500">block</mat-icon>
          </div>
        }
      </td>
    </ng-container>

    <ng-container matColumnDef="detailView">
      <th mat-header-cell *matHeaderCellDef></th>
      <td mat-cell *matCellDef="let customComponent">
        <button
          class="justify-content-end p-0"
          mat-button
          color="primary"
          (click)="goToConformanceTests(customComponent.id)"
        >
          <mat-icon class="arrow-forward-icon">arrow_forward</mat-icon>
        </button>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr
      mat-row
      (click)="isWizard ? selectComponent(row) : null"
      (keydown)="isWizard ? selectComponent(row) : null"
      [class.row-is-clicked]="
        !!selectedComponent && selectedComponent.id === row.id
      "
      *matRowDef="let row; columns: displayedColumns"
    ></tr>
  </table>
</div>
